rc.subr revision 170282
1243789Sdim# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2243789Sdim# $FreeBSD: head/etc/rc.subr 170282 2007-06-04 11:39:35Z yar $
3243789Sdim#
4243789Sdim# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5243789Sdim# All rights reserved.
6243789Sdim#
7243789Sdim# This code is derived from software contributed to The NetBSD Foundation
8243789Sdim# by Luke Mewburn.
9243789Sdim#
10243789Sdim# Redistribution and use in source and binary forms, with or without
11243789Sdim# modification, are permitted provided that the following conditions
12243789Sdim# are met:
13243789Sdim# 1. Redistributions of source code must retain the above copyright
14243789Sdim#    notice, this list of conditions and the following disclaimer.
15243789Sdim# 2. Redistributions in binary form must reproduce the above copyright
16249423Sdim#    notice, this list of conditions and the following disclaimer in the
17249423Sdim#    documentation and/or other materials provided with the distribution.
18243789Sdim# 3. All advertising materials mentioning features or use of this software
19249423Sdim#    must display the following acknowledgement:
20249423Sdim#        This product includes software developed by the NetBSD
21249423Sdim#        Foundation, Inc. and its contributors.
22243789Sdim# 4. Neither the name of The NetBSD Foundation nor the names of its
23243789Sdim#    contributors may be used to endorse or promote products derived
24243789Sdim#    from this software without specific prior written permission.
25243789Sdim#
26243789Sdim# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
27243789Sdim# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
28243789Sdim# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
29243789Sdim# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
30243789Sdim# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
31243789Sdim# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
32243789Sdim# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
33243789Sdim# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
34243789Sdim# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
35243789Sdim# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
36243789Sdim# POSSIBILITY OF SUCH DAMAGE.
37243789Sdim#
38243789Sdim# rc.subr
39243789Sdim#	functions used by various rc scripts
40243789Sdim#
41243789Sdim
42243789Sdim: ${rcvar_manpage:='rc.conf(5)'}
43243789Sdim: ${RC_PID:=$$}; export RC_PID
44243789Sdim
45243789Sdim#
46243789Sdim#	Operating System dependent/independent variables
47243789Sdim#
48243789Sdim
49243789Sdimif [ -z "${_rc_subr_loaded}" ]; then
50243789Sdim
51243789Sdim_rc_subr_loaded="YES"
52243789Sdim
53243789SdimSYSCTL="/sbin/sysctl"
54243789SdimSYSCTL_N="${SYSCTL} -n"
55243789SdimCMD_OSTYPE="${SYSCTL_N} kern.ostype"
56243789SdimOSTYPE=`${CMD_OSTYPE}`
57243789SdimID="/usr/bin/id"
58243789SdimIDCMD="if [ -x $ID ]; then $ID -un; fi"
59243789SdimPS="/bin/ps -ww"
60243789SdimJID=`$PS -p $$ -o jid=`
61243789Sdim
62243789Sdimcase ${OSTYPE} in
63243789SdimFreeBSD)
64243789Sdim	SYSCTL_W="${SYSCTL}"
65243789Sdim	;;
66243789SdimNetBSD)
67243789Sdim	SYSCTL_W="${SYSCTL} -w"
68243789Sdim	;;
69243789Sdimesac
70243789Sdim
71243789Sdim#
72243789Sdim#	functions
73243789Sdim#	---------
74243789Sdim
75243789Sdim#
76243789Sdim# set_rcvar base_var
77243789Sdim#	Set the variable name enabling a specific service.
78243789Sdim#	FreeBSD uses ${service}_enable, while NetBSD uses
79243789Sdim#	just the name of the service. For example:
80243789Sdim#	FreeBSD: sendmail_enable="YES"
81243789Sdim#	NetBSD : sendmail="YES"
82243789Sdim#	$1 - if $name is not the base to work of off, specify
83243789Sdim#	     a different one
84243789Sdim#
85243789Sdimset_rcvar()
86243789Sdim{
87243789Sdim	if [ -z "$1" ]; then
88243789Sdim		base_var=${name}
89243789Sdim	else
90243789Sdim		base_var="$1"
91243789Sdim	fi
92243789Sdim
93243789Sdim	case ${OSTYPE} in
94243789Sdim	FreeBSD)
95243789Sdim		echo ${base_var}_enable
96243789Sdim		;;
97243789Sdim	NetBSD)
98243789Sdim		echo ${base_var}
99243789Sdim		;;
100243789Sdim	*)
101243789Sdim		echo 'XXX'
102243789Sdim		;;
103243789Sdim	esac
104243789Sdim}
105243789Sdim
106243789Sdim#
107243789Sdim# force_depend script
108243789Sdim#	Force a service to start. Intended for use by services
109243789Sdim#	to resolve dependency issues. It is assumed the caller
110243789Sdim#	has check to make sure this call is necessary
111243789Sdim#	$1 - filename of script, in /etc/rc.d, to run
112243789Sdim#
113243789Sdimforce_depend()
114243789Sdim{
115243789Sdim	_depend="$1"
116243789Sdim
117243789Sdim	info "${name} depends on ${_depend}, which will be forced to start."
118243789Sdim	if ! /etc/rc.d/${_depend} forcestart; then
119243789Sdim		warn "Unable to force ${_depend}. It may already be running."
120243789Sdim		return 1
121243789Sdim	fi
122243789Sdim	return 0
123243789Sdim}
124243789Sdim
125243789Sdim#
126243789Sdim# checkyesno var
127243789Sdim#	Test $1 variable, and warn if not set to YES or NO.
128243789Sdim#	Return 0 if it's "yes" (et al), nonzero otherwise.
129243789Sdim#
130243789Sdimcheckyesno()
131263508Sdim{
132263508Sdim	eval _value=\$${1}
133263508Sdim	debug "checkyesno: $1 is set to $_value."
134263508Sdim	case $_value in
135263508Sdim
136263508Sdim		#	"yes", "true", "on", or "1"
137263508Sdim	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
138263508Sdim		return 0
139263508Sdim		;;
140243789Sdim
141243789Sdim		#	"no", "false", "off", or "0"
142263508Sdim	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
143243789Sdim		return 1
144243789Sdim		;;
145243789Sdim	*)
146263508Sdim		warn "\$${1} is not set properly - see ${rcvar_manpage}."
147263508Sdim		return 1
148243789Sdim		;;
149243789Sdim	esac
150243789Sdim}
151243789Sdim
152243789Sdim#
153243789Sdim# reverse_list list
154243789Sdim#	print the list in reverse order
155263508Sdim#
156263508Sdimreverse_list()
157263508Sdim{
158263508Sdim	_revlist=
159263508Sdim	for _revfile; do
160263508Sdim		_revlist="$_revfile $_revlist"
161263508Sdim	done
162243789Sdim	echo $_revlist
163243789Sdim}
164243789Sdim
165243789Sdim# stop_boot always
166243789Sdim#	If booting directly to multiuser or $always is enabled,
167243789Sdim#	send SIGTERM to the parent (/etc/rc) to abort the boot.
168243789Sdim#	Otherwise just exit.
169243789Sdim#
170243789Sdimstop_boot()
171243789Sdim{
172243789Sdim	local always
173
174	if [ -n "$1" ] && checkyesno $1; then
175		always=true
176	else
177		always=false
178	fi
179	if [ "$autoboot" = yes -o "$always" = true ]; then
180		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
181		kill -TERM ${RC_PID}
182	fi
183	exit 1
184}
185
186#
187# mount_critical_filesystems type
188#	Go through the list of critical filesystems as provided in
189#	the rc.conf(5) variable $critical_filesystems_${type}, checking
190#	each one to see if it is mounted, and if it is not, mounting it.
191#
192mount_critical_filesystems()
193{
194	eval _fslist=\$critical_filesystems_${1}
195	for _fs in $_fslist; do
196		mount | (
197			_ismounted=false
198			while read what _on on _type type; do
199				if [ $on = $_fs ]; then
200					_ismounted=true
201				fi
202			done
203			if $_ismounted; then
204				:
205			else
206				mount $_fs >/dev/null 2>&1
207			fi
208		)
209	done
210}
211
212#
213# check_pidfile pidfile procname [interpreter]
214#	Parses the first line of pidfile for a PID, and ensures
215#	that the process is running and matches procname.
216#	Prints the matching PID upon success, nothing otherwise.
217#	interpreter is optional; see _find_processes() for details.
218#
219check_pidfile()
220{
221	_pidfile=$1
222	_procname=$2
223	_interpreter=$3
224	if [ -z "$_pidfile" -o -z "$_procname" ]; then
225		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
226	fi
227	if [ ! -f $_pidfile ]; then
228		debug "pid file ($_pidfile): not readable."
229		return
230	fi
231	read _pid _junk < $_pidfile
232	if [ -z "$_pid" ]; then
233		debug "pid file ($_pidfile): no pid in file."
234		return
235	fi
236	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
237}
238
239#
240# check_process procname [interpreter]
241#	Ensures that a process (or processes) named procname is running.
242#	Prints a list of matching PIDs.
243#	interpreter is optional; see _find_processes() for details.
244#
245check_process()
246{
247	_procname=$1
248	_interpreter=$2
249	if [ -z "$_procname" ]; then
250		err 3 'USAGE: check_process procname [interpreter]'
251	fi
252	_find_processes $_procname ${_interpreter:-.} '-ax'
253}
254
255#
256# _find_processes procname interpreter psargs
257#	Search for procname in the output of ps generated by psargs.
258#	Prints the PIDs of any matching processes, space separated.
259#
260#	If interpreter == ".", check the following variations of procname
261#	against the first word of each command:
262#		procname
263#		`basename procname`
264#		`basename procname` + ":"
265#		"(" + `basename procname` + ")"
266#		"[" + `basename procname` + "]"
267#
268#	If interpreter != ".", read the first line of procname, remove the
269#	leading #!, normalise whitespace, append procname, and attempt to
270#	match that against each command, either as is, or with extra words
271#	at the end.  As an alternative, to deal with interpreted daemons
272#	using perl, the basename of the interpreter plus a colon is also
273#	tried as the prefix to procname.
274#
275_find_processes()
276{
277	if [ $# -ne 3 ]; then
278		err 3 'USAGE: _find_processes procname interpreter psargs'
279	fi
280	_procname=$1
281	_interpreter=$2
282	_psargs=$3
283
284	_pref=
285	if [ $_interpreter != "." ]; then	# an interpreted script
286		_script=${_chroot}${_chroot:+"/"}$_procname
287		if [ -r $_script ]; then
288			read _interp < $_script	# read interpreter name
289			case "$_interp" in
290			\#!*)
291				_interp=${_interp#\#!}	# strip #!
292				set -- $_interp
293				case $1 in
294				*/bin/env)
295					shift	# drop env to get real name
296					;;
297				esac
298				if [ $_interpreter != $1 ]; then
299					warn "\$command_interpreter $_interpreter != $1"
300				fi
301				;;
302			*)
303				warn "no shebang line in $_script"
304				set -- $_interpreter
305				;;
306			esac
307		else
308			warn "cannot read shebang line from $_script"
309			set -- $_interpreter
310		fi
311		_interp="$* $_procname"		# cleanup spaces, add _procname
312		_interpbn=${1##*/}
313		_fp_args='_argv'
314		_fp_match='case "$_argv" in
315		    ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
316	else					# a normal daemon
317		_procnamebn=${_procname##*/}
318		_fp_args='_arg0 _argv'
319		_fp_match='case "$_arg0" in
320		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
321	fi
322
323	_proccheck="\
324		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
325		while read _npid _jid '"$_fp_args"'; do
326			'"$_fp_match"'
327				if [ "$JID" -eq "$_jid" ];
328				then echo -n "$_pref$_npid";
329				_pref=" ";
330				fi
331				;;
332			esac
333		done'
334
335#	debug "in _find_processes: proccheck is ($_proccheck)."
336	eval $_proccheck
337}
338
339#
340# wait_for_pids pid [pid ...]
341#	spins until none of the pids exist
342#
343wait_for_pids()
344{
345	_list="$@"
346	if [ -z "$_list" ]; then
347		return
348	fi
349	_prefix=
350	while true; do
351		_nlist="";
352		for _j in $_list; do
353			if kill -0 $_j 2>/dev/null; then
354				_nlist="${_nlist}${_nlist:+ }$_j"
355			fi
356		done
357		if [ -z "$_nlist" ]; then
358			break
359		fi
360		_list=$_nlist
361		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
362		_prefix=", "
363		sleep 2
364	done
365	if [ -n "$_prefix" ]; then
366		echo "."
367	fi
368}
369
370#
371# run_rc_command argument
372#	Search for argument in the list of supported commands, which is:
373#		"start stop restart rcvar status poll ${extra_commands}"
374#	If there's a match, run ${argument}_cmd or the default method
375#	(see below).
376#
377#	If argument has a given prefix, then change the operation as follows:
378#		Prefix	Operation
379#		------	---------
380#		fast	Skip the pid check, and set rc_fast=yes
381#		force	Set ${rcvar} to YES, and set rc_force=yes
382#		one	Set ${rcvar} to YES
383#
384#	The following globals are used:
385#
386#	Name		Needed	Purpose
387#	----		------	-------
388#	name		y	Name of script.
389#
390#	command		n	Full path to command.
391#				Not needed if ${rc_arg}_cmd is set for
392#				each keyword.
393#
394#	command_args	n	Optional args/shell directives for command.
395#
396#	command_interpreter n	If not empty, command is interpreted, so
397#				call check_{pidfile,process}() appropriately.
398#
399#	extra_commands	n	List of extra commands supported.
400#
401#	pidfile		n	If set, use check_pidfile $pidfile $command,
402#				otherwise use check_process $command.
403#				In either case, only check if $command is set.
404#
405#	procname	n	Process name to check for instead of $command.
406#
407#	rcvar		n	This is checked with checkyesno to determine
408#				if the action should be run.
409#
410#	${name}_program	n	Full path to command.
411#				Meant to be used in /etc/rc.conf to override
412#				${command}.
413#
414#	${name}_chroot	n	Directory to chroot to before running ${command}
415#				Requires /usr to be mounted.
416#
417#	${name}_chdir	n	Directory to cd to before running ${command}
418#				(if not using ${name}_chroot).
419#
420#	${name}_flags	n	Arguments to call ${command} with.
421#				NOTE:	$flags from the parent environment
422#					can be used to override this.
423#
424#	${name}_nice	n	Nice level to run ${command} at.
425#
426#	${name}_user	n	User to run ${command} as, using su(1) if not
427#				using ${name}_chroot.
428#				Requires /usr to be mounted.
429#
430#	${name}_group	n	Group to run chrooted ${command} as.
431#				Requires /usr to be mounted.
432#
433#	${name}_groups	n	Comma separated list of supplementary groups
434#				to run the chrooted ${command} with.
435#				Requires /usr to be mounted.
436#
437#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
438#				Otherwise, use default command (see below)
439#
440#	${rc_arg}_precmd n	If set, run just before performing the
441#				${rc_arg}_cmd method in the default
442#				operation (i.e, after checking for required
443#				bits and process (non)existence).
444#				If this completes with a non-zero exit code,
445#				don't run ${rc_arg}_cmd.
446#
447#	${rc_arg}_postcmd n	If set, run just after performing the
448#				${rc_arg}_cmd method, if that method
449#				returned a zero exit code.
450#
451#	required_dirs	n	If set, check for the existence of the given
452#				directories before running a (re)start command.
453#
454#	required_files	n	If set, check for the readability of the given
455#				files before running a (re)start command.
456#
457#	required_modules n	If set, ensure the given kernel modules are
458#				loaded before running a (re)start command.
459#				The check and possible loads are actually
460#				done after start_precmd so that the modules
461#				aren't loaded in vain, should the precmd
462#				return a non-zero status to indicate a error.
463#				If a word in the list looks like "foo:bar",
464#				"foo" is the KLD file name and "bar" is the
465#				module name.  If a word looks like "foo~bar",
466#				"foo" is the KLD file name and "bar" is a
467#				egrep(1) pattern matching the module name.
468#				Otherwise the module name is assumed to be
469#				the same as the KLD file name, which is most
470#				common.  See load_kld().
471#
472#	required_vars	n	If set, perform checkyesno on each of the
473#				listed variables before running the default
474#				(re)start command.
475#
476#	Default behaviour for a given argument, if no override method is
477#	provided:
478#
479#	Argument	Default behaviour
480#	--------	-----------------
481#	start		if !running && checkyesno ${rcvar}
482#				${command}
483#
484#	stop		if ${pidfile}
485#				rc_pid=$(check_pidfile $pidfile $command)
486#			else
487#				rc_pid=$(check_process $command)
488#			kill $sig_stop $rc_pid
489#			wait_for_pids $rc_pid
490#			($sig_stop defaults to TERM.)
491#
492#	reload		Similar to stop, except use $sig_reload instead,
493#			and doesn't wait_for_pids.
494#			$sig_reload defaults to HUP.
495#			Note that `reload' isn't provided by default,
496#			it should be enabled via $extra_commands.
497#
498#	restart		Run `stop' then `start'.
499#
500#	status		Show if ${command} is running, etc.
501#
502#	poll		Wait for ${command} to exit.
503#
504#	rcvar		Display what rc.conf variable is used (if any).
505#
506#	Variables available to methods, and after run_rc_command() has
507#	completed:
508#
509#	Variable	Purpose
510#	--------	-------
511#	rc_arg		Argument to command, after fast/force/one processing
512#			performed
513#
514#	rc_flags	Flags to start the default command with.
515#			Defaults to ${name}_flags, unless overridden
516#			by $flags from the environment.
517#			This variable may be changed by the precmd method.
518#
519#	rc_pid		PID of command (if appropriate)
520#
521#	rc_fast		Not empty if "fast" was provided (q.v.)
522#
523#	rc_force	Not empty if "force" was provided (q.v.)
524#
525#
526run_rc_command()
527{
528	_return=0
529	rc_arg=$1
530	if [ -z "$name" ]; then
531		err 3 'run_rc_command: $name is not set.'
532	fi
533
534	# Don't repeat the first argument when passing additional command-
535	# line arguments to the command subroutines.
536	#
537	shift 1
538	rc_extra_args="$*"
539
540	_rc_prefix=
541	case "$rc_arg" in
542	fast*)				# "fast" prefix; don't check pid
543		rc_arg=${rc_arg#fast}
544		rc_fast=yes
545		;;
546	force*)				# "force prefix; always run
547		rc_force=yes
548		_rc_prefix=force
549		rc_arg=${rc_arg#${_rc_prefix}}
550		if [ -n "${rcvar}" ]; then
551			eval ${rcvar}=YES
552		fi
553		;;
554	one*)				# "one" prefix; set ${rcvar}=yes
555		_rc_prefix=one
556		rc_arg=${rc_arg#${_rc_prefix}}
557		if [ -n "${rcvar}" ]; then
558			eval ${rcvar}=YES
559		fi
560		;;
561	esac
562
563	eval _override_command=\$${name}_program
564	command=${command:+${_override_command:-$command}}
565
566	_keywords="start stop restart rcvar $extra_commands"
567	rc_pid=
568	_pidcmd=
569	_procname=${procname:-${command}}
570
571					# setup pid check command
572	if [ -n "$_procname" ]; then
573		if [ -n "$pidfile" ]; then
574			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
575		else
576			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
577		fi
578		if [ -n "$_pidcmd" ]; then
579			_keywords="${_keywords} status poll"
580		fi
581	fi
582
583	if [ -z "$rc_arg" ]; then
584		rc_usage $_keywords
585	fi
586
587	if [ -n "$flags" ]; then	# allow override from environment
588		rc_flags=$flags
589	else
590		eval rc_flags=\$${name}_flags
591	fi
592	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
593	    _nice=\$${name}_nice	_user=\$${name}_user \
594	    _group=\$${name}_group	_groups=\$${name}_groups
595
596	if [ -n "$_user" ]; then	# unset $_user if running as that user
597		if [ "$_user" = "$(eval $IDCMD)" ]; then
598			unset _user
599		fi
600	fi
601
602					# if ${rcvar} is set, and $1 is not
603					# "rcvar", then run
604					#	checkyesno ${rcvar}
605					# and return if that failed
606					#
607	if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
608		if ! checkyesno ${rcvar}; then
609			return 0
610		fi
611	fi
612
613	eval $_pidcmd			# determine the pid if necessary
614
615	for _elem in $_keywords; do
616		if [ "$_elem" != "$rc_arg" ]; then
617			continue
618		fi
619					# if there's a custom ${XXX_cmd},
620					# run that instead of the default
621					#
622		eval _cmd=\$${rc_arg}_cmd \
623		     _precmd=\$${rc_arg}_precmd \
624		     _postcmd=\$${rc_arg}_postcmd
625
626		if [ -n "$_cmd" ]; then
627			_run_rc_precmd || return 1
628			_run_rc_doit "$_cmd $rc_extra_args" || return 1
629			_run_rc_postcmd
630			return $_return
631		fi
632
633		case "$rc_arg" in	# default operations...
634
635		status)
636			_run_rc_precmd || return 1
637			if [ -n "$rc_pid" ]; then
638				echo "${name} is running as pid $rc_pid."
639			else
640				echo "${name} is not running."
641				return 1
642			fi
643			_run_rc_postcmd
644			;;
645
646		start)
647			if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
648				echo 1>&2 "${name} already running? (pid=$rc_pid)."
649				return 1
650			fi
651
652			if [ ! -x ${_chroot}${_chroot:+"/"}${command} ]; then
653				warn "run_rc_command: cannot run $command"
654				return 1
655			fi
656
657			_run_rc_precmd || return 1
658
659					# setup the full command to run
660					#
661			echo "Starting ${name}."
662			if [ -n "$_chroot" ]; then
663				_doit="\
664${_nice:+nice -n $_nice }\
665chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
666$_chroot $command $rc_flags $command_args"
667			else
668				_doit="\
669${_chdir:+cd $_chdir && }\
670$command $rc_flags $command_args"
671				if [ -n "$_user" ]; then
672				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
673				fi
674				if [ -n "$_nice" ]; then
675					if [ -z "$_user" ]; then
676						_doit="sh -c \"$_doit\""
677					fi	
678					_doit="nice -n $_nice $_doit"
679				fi
680			fi
681
682					# run the full command
683					#
684			_run_rc_doit "$_doit" || return 1
685
686					# finally, run postcmd
687					#
688			_run_rc_postcmd
689			;;
690
691		stop)
692			if [ -z "$rc_pid" ]; then
693				[ -n "$rc_fast" ] && return 0
694				_run_rc_notrunning
695				return 1
696			fi
697
698			_run_rc_precmd || return 1
699
700					# send the signal to stop
701					#
702			echo "Stopping ${name}."
703			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
704			_run_rc_doit "$_doit" || return 1
705
706					# wait for the command to exit,
707					# and run postcmd.
708			wait_for_pids $rc_pid
709
710			_run_rc_postcmd
711			;;
712
713		reload)
714			if [ -z "$rc_pid" ]; then
715				_run_rc_notrunning
716				return 1
717			fi
718
719			_run_rc_precmd || return 1
720
721			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
722			_run_rc_doit "$_doit" || return 1
723
724			_run_rc_postcmd
725			;;
726
727		restart)
728					# prevent restart being called more
729					# than once by any given script
730					#
731			if ${_rc_restart_done:-false}; then
732				return 0
733			fi
734			_rc_restart_done=true
735
736			_run_rc_precmd || return 1
737
738			# run those in a subshell to keep global variables
739			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
740			( run_rc_command ${_rc_prefix}start $rc_extra_args )
741			_return=$?
742			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
743
744			_run_rc_postcmd
745			;;
746
747		poll)
748			_run_rc_precmd || return 1
749			if [ -n "$rc_pid" ]; then
750				wait_for_pids $rc_pid
751			fi
752			_run_rc_postcmd
753			;;
754
755		rcvar)
756			echo "# $name"
757			if [ -n "$rcvar" ]; then
758				if checkyesno ${rcvar}; then
759					echo "${rcvar}=YES"
760				else
761					echo "${rcvar}=NO"
762				fi
763			fi
764			;;
765
766		*)
767			rc_usage $_keywords
768			;;
769
770		esac
771		return $_return
772	done
773
774	echo 1>&2 "$0: unknown directive '$rc_arg'."
775	rc_usage $_keywords
776	# not reached
777}
778
779#
780# Helper functions for run_rc_command: common code.
781# They use such global variables besides the exported rc_* ones:
782#
783#	name	       R/W
784#	------------------
785#	_precmd		R
786#	_postcmd	R
787#	_return		W
788#
789_run_rc_precmd()
790{
791	check_required_before "$rc_arg" || return 1
792
793	if [ -n "$_precmd" ]; then
794		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
795		eval "$_precmd $rc_extra_args"
796		_return=$?
797
798		# If precmd failed and force isn't set, request exit.
799		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
800			return 1
801		fi
802	fi
803
804	check_required_after "$rc_arg" || return 1
805
806	return 0
807}
808
809_run_rc_postcmd()
810{
811	if [ -n "$_postcmd" ]; then
812		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
813		eval "$_postcmd $rc_extra_args"
814		_return=$?
815	fi
816	return 0
817}
818
819_run_rc_doit()
820{
821	debug "run_rc_command: doit: $*"
822	eval "$@"
823	_return=$?
824
825	# If command failed and force isn't set, request exit.
826	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
827		return 1
828	fi
829
830	return 0
831}
832
833_run_rc_notrunning()
834{
835	local _pidmsg
836
837	if [ -n "$pidfile" ]; then
838		_pidmsg=" (check $pidfile)."
839	else
840		_pidmsg=
841	fi
842	echo 1>&2 "${name} not running?${_pidmsg}"
843}
844
845_run_rc_killcmd()
846{
847	local _cmd
848
849	_cmd="kill -$1 $rc_pid"
850	if [ -n "$_user" ]; then
851		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
852	fi
853	echo "$_cmd"
854}
855
856#
857# run_rc_script file arg
858#	Start the script `file' with `arg', and correctly handle the
859#	return value from the script.  If `file' ends with `.sh', it's
860#	sourced into the current environment.  If `file' appears to be
861#	a backup or scratch file, ignore it.  Otherwise if it's
862#	executable run as a child process.
863#
864run_rc_script()
865{
866	_file=$1
867	_arg=$2
868	if [ -z "$_file" -o -z "$_arg" ]; then
869		err 3 'USAGE: run_rc_script file arg'
870	fi
871
872	unset	name command command_args command_interpreter \
873		extra_commands pidfile procname \
874		rcvar required_dirs required_files required_vars
875	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
876
877	case "$_file" in
878	/etc/rc.d/*.sh)			# run in current shell
879		set $_arg; . $_file
880		;;
881	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
882		warn "Ignoring scratch file $_file"
883		;;
884	*)				# run in subshell
885		if [ -x $_file ]; then
886			if [ -n "$rc_fast_and_loose" ]; then
887				set $_arg; . $_file
888			else
889				( trap "echo Script $_file interrupted; kill -QUIT $$" 3
890				  trap "echo Script $_file interrupted; exit 1" 2
891				  set $_arg; . $_file )
892			fi
893		fi
894		;;
895	esac
896}
897
898#
899# load_rc_config name
900#	Source in the configuration file for a given name.
901#
902load_rc_config()
903{
904	_name=$1
905	if [ -z "$_name" ]; then
906		err 3 'USAGE: load_rc_config name'
907	fi
908
909	if ${_rc_conf_loaded:-false}; then
910		:
911	else
912		if [ -r /etc/defaults/rc.conf ]; then
913			debug "Sourcing /etc/defaults/rc.conf"
914			. /etc/defaults/rc.conf
915			source_rc_confs
916		elif [ -r /etc/rc.conf ]; then
917			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
918			. /etc/rc.conf
919		fi
920		_rc_conf_loaded=true
921	fi
922	if [ -f /etc/rc.conf.d/"$_name" ]; then
923		debug "Sourcing /etc/rc.conf.d/${_name}"
924		. /etc/rc.conf.d/"$_name"
925	fi
926
927	# XXX - Deprecated variable name support
928	#
929	case ${OSTYPE} in
930	FreeBSD)
931		[ -n "$portmap_enable" ] && rpcbind_enable="$portmap_enable"
932		[ -n "$portmap_program" ] && rpcbind_program="$portmap_program"
933		[ -n "$portmap_flags" ] && rpcbind_flags="$portmap_flags"
934		[ -n "$single_mountd_enable" ] && mountd_enable="$single_mountd_enable"
935		[ -n "$xntpd_enable" ] && ntpd_enable="$xntpd_enable"
936		[ -n "$xntpd_program" ] && ntpd_program="$xntpd_program"
937		[ -n "$xntpd_flags" ] && ntpd_flags="$xntpd_flags"
938		[ -n "$dhcp_program" ] && dhclient_program="$dhcp_program"
939		[ -n "$dhcp_flags" ] && dhclient_flags="$dhcp_flags"
940		;;
941	esac
942}
943  
944#
945# load_rc_config_var name var
946#	Read the rc.conf(5) var for name and set in the
947#	current shell, using load_rc_config in a subshell to prevent
948#	unwanted side effects from other variable assignments.
949#
950load_rc_config_var()
951{
952	if [ $# -ne 2 ]; then
953		err 3 'USAGE: load_rc_config_var name var'
954	fi
955	eval $(eval '(
956		load_rc_config '$1' >/dev/null;
957                if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
958			echo '$2'=\'\''${'$2'}\'\'';
959		fi
960	)' )
961}
962
963#
964# rc_usage commands
965#	Print a usage string for $0, with `commands' being a list of
966#	valid commands.
967#
968rc_usage()
969{
970	echo -n 1>&2 "Usage: $0 [fast|force|one]("
971
972	_sep=
973	for _elem; do
974		echo -n 1>&2 "$_sep$_elem"
975		_sep="|"
976	done
977	echo 1>&2 ")"
978	exit 1
979}
980
981#
982# err exitval message
983#	Display message to stderr and log to the syslog, and exit with exitval.
984#
985err()
986{
987	exitval=$1
988	shift
989
990	if [ -x /usr/bin/logger ]; then
991		logger "$0: ERROR: $*"
992	fi
993	echo 1>&2 "$0: ERROR: $*"
994	exit $exitval
995}
996
997#
998# warn message
999#	Display message to stderr and log to the syslog.
1000#
1001warn()
1002{
1003	if [ -x /usr/bin/logger ]; then
1004		logger "$0: WARNING: $*"
1005	fi
1006	echo 1>&2 "$0: WARNING: $*"
1007}
1008
1009#
1010# info message
1011#	Display informational message to stdout and log to syslog.
1012#
1013info()
1014{
1015	case ${rc_info} in
1016	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1017		if [ -x /usr/bin/logger ]; then
1018			logger "$0: INFO: $*"
1019		fi
1020		echo "$0: INFO: $*"
1021		;;
1022	esac
1023}
1024
1025#
1026# debug message
1027#	If debugging is enabled in rc.conf output message to stderr.
1028#	BEWARE that you don't call any subroutine that itself calls this
1029#	function.
1030#
1031debug()
1032{
1033	case ${rc_debug} in
1034	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1035		if [ -x /usr/bin/logger ]; then
1036			logger "$0: DEBUG: $*"
1037		fi
1038		echo 1>&2 "$0: DEBUG: $*"
1039		;;
1040	esac
1041}
1042
1043#
1044# backup_file action file cur backup
1045#	Make a backup copy of `file' into `cur', and save the previous
1046#	version of `cur' as `backup' or use rcs for archiving.
1047#
1048#	This routine checks the value of the backup_uses_rcs variable,
1049#	which can be either YES or NO.
1050#
1051#	The `action' keyword can be one of the following:
1052#
1053#	add		`file' is now being backed up (and is possibly
1054#			being reentered into the backups system).  `cur'
1055#			is created and RCS files, if necessary, are
1056#			created as well.
1057#
1058#	update		`file' has changed and needs to be backed up.
1059#			If `cur' exists, it is copied to to `back' or
1060#			checked into RCS (if the repository file is old),
1061#			and then `file' is copied to `cur'.  Another RCS
1062#			check in done here if RCS is being used.
1063#
1064#	remove		`file' is no longer being tracked by the backups
1065#			system.  If RCS is not being used, `cur' is moved
1066#			to `back', otherwise an empty file is checked in,
1067#			and then `cur' is removed.
1068#
1069#
1070backup_file()
1071{
1072	_action=$1
1073	_file=$2
1074	_cur=$3
1075	_back=$4
1076
1077	if checkyesno backup_uses_rcs; then
1078		_msg0="backup archive"
1079		_msg1="update"
1080
1081		# ensure that history file is not locked
1082		if [ -f $_cur,v ]; then
1083			rcs -q -u -U -M $_cur
1084		fi
1085
1086		# ensure after switching to rcs that the
1087		# current backup is not lost
1088		if [ -f $_cur ]; then
1089			# no archive, or current newer than archive
1090			if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1091				ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1092				rcs -q -kb -U $_cur
1093				co -q -f -u $_cur
1094			fi
1095		fi
1096
1097		case $_action in
1098		add|update)
1099			cp -p $_file $_cur
1100			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1101			rcs -q -kb -U $_cur
1102			co -q -f -u $_cur
1103			chown root:wheel $_cur $_cur,v
1104			;;
1105		remove)
1106			cp /dev/null $_cur
1107			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1108			rcs -q -kb -U $_cur
1109			chown root:wheel $_cur $_cur,v
1110			rm $_cur
1111			;;
1112		esac
1113	else
1114		case $_action in
1115		add|update)
1116			if [ -f $_cur ]; then
1117				cp -p $_cur $_back
1118			fi
1119			cp -p $_file $_cur
1120			chown root:wheel $_cur
1121			;;
1122		remove)
1123			mv -f $_cur $_back
1124			;;
1125		esac
1126	fi
1127}
1128
1129# make_symlink src link
1130#	Make a symbolic link 'link' to src from basedir. If the
1131#	directory in which link is to be created does not exist
1132#	a warning will be displayed and an error will be returned.
1133#	Returns 0 on sucess, 1 otherwise.
1134#
1135make_symlink()
1136{
1137	local src link linkdir _me
1138	src="$1"
1139	link="$2"
1140	linkdir="`dirname $link`"
1141	_me="make_symlink()"
1142
1143	if [ -z "$src" -o -z "$link" ]; then
1144		warn "$_me: requires two arguments."
1145		return 1
1146	fi
1147	if [ ! -d "$linkdir" ]; then
1148		warn "$_me: the directory $linkdir does not exist."
1149		return 1
1150	fi
1151	if ! ln -sf $src $link; then
1152		warn "$_me: unable to make a symbolic link from $link to $src"
1153		return 1
1154	fi
1155	return 0
1156}
1157
1158# devfs_rulesets_from_file file
1159#	Reads a set of devfs commands from file, and creates
1160#	the specified rulesets with their rules. Returns non-zero
1161#	if there was an error.
1162#
1163devfs_rulesets_from_file()
1164{
1165	local file _err _me
1166	file="$1"
1167	_me="devfs_rulesets_from_file"
1168	_err=0
1169
1170	if [ -z "$file" ]; then
1171		warn "$_me: you must specify a file"
1172		return 1
1173	fi
1174	if [ ! -e "$file" ]; then
1175		debug "$_me: no such file ($file)"
1176		return 0
1177	fi
1178	debug "reading rulesets from file ($file)"
1179	{ while read line
1180	do
1181		case $line in
1182		\#*)
1183			continue
1184			;;
1185		\[*\]*)
1186			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1187			if [ -z "$rulenum" ]; then
1188				warn "$_me: cannot extract rule number ($line)"
1189				_err=1
1190				break
1191			fi
1192			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1193			if [ -z "$rulename" ]; then
1194				warn "$_me: cannot extract rule name ($line)"
1195				_err=1
1196				break;
1197			fi
1198			eval $rulename=\$rulenum
1199			debug "found ruleset: $rulename=$rulenum"
1200			if ! /sbin/devfs rule -s $rulenum delset; then
1201				_err=1
1202				break
1203			fi
1204			;;
1205		*)
1206			rulecmd="${line%%"\#*"}"
1207			# evaluate the command incase it includes
1208			# other rules
1209			if [ -n "$rulecmd" ]; then
1210				debug "adding rule ($rulecmd)"
1211				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1212				then
1213					_err=1
1214					break
1215				fi
1216			fi
1217			;;
1218		esac
1219		if [ $_err -ne 0 ]; then
1220			debug "error in $_me"
1221			break
1222		fi
1223	done } < $file
1224	return $_err
1225}
1226
1227# devfs_init_rulesets
1228#	Initializes rulesets from configuration files. Returns
1229#	non-zero if there was an error.
1230#
1231devfs_init_rulesets()
1232{
1233	local file _me
1234	_me="devfs_init_rulesets"
1235
1236	# Go through this only once
1237	if [ -n "$devfs_rulesets_init" ]; then
1238		debug "$_me: devfs rulesets already initialized"
1239		return
1240	fi
1241	for file in $devfs_rulesets; do
1242		devfs_rulesets_from_file $file || return 1
1243	done
1244	devfs_rulesets_init=1
1245	debug "$_me: devfs rulesets initialized"
1246	return 0
1247}
1248
1249# devfs_set_ruleset ruleset [dir]
1250#	Sets the default ruleset of dir to ruleset. The ruleset argument
1251#	must be a ruleset name as specified in devfs.rules(5) file.
1252#	Returns non-zero if it could not set it successfully.
1253#
1254devfs_set_ruleset()
1255{
1256	local devdir rs _me
1257	[ -n "$1" ] && eval rs=\$$1 || rs=
1258	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1259	_me="devfs_set_ruleset"
1260
1261	if [ -z "$rs" ]; then
1262		warn "$_me: you must specify a ruleset number"
1263		return 1
1264	fi
1265	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1266	if ! /sbin/devfs $devdir ruleset $rs; then
1267		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1268		return 1
1269	fi
1270	return 0
1271}
1272
1273# devfs_apply_ruleset ruleset [dir]
1274#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1275#	The ruleset argument must be a ruleset name as specified
1276#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1277#	if it could not apply the ruleset.
1278#
1279devfs_apply_ruleset()
1280{
1281	local devdir rs _me
1282	[ -n "$1" ] && eval rs=\$$1 || rs=
1283	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1284	_me="devfs_apply_ruleset"
1285
1286	if [ -z "$rs" ]; then
1287		warn "$_me: you must specify a ruleset"
1288		return 1
1289	fi
1290	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1291	if ! /sbin/devfs $devdir rule -s $rs applyset; then
1292		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1293		return 1
1294	fi
1295	return 0
1296}
1297
1298# devfs_domount dir [ruleset]
1299#	Mount devfs on dir. If ruleset is specified it is set
1300#	on the mount-point. It must also be a ruleset name as specified
1301#	in a devfs.rules(5) file. Returns 0 on success.
1302#
1303devfs_domount()
1304{
1305	local devdir rs _me
1306	devdir="$1"
1307	[ -n "$2" ] && rs=$2 || rs=
1308	_me="devfs_domount()"
1309
1310	if [ -z "$devdir" ]; then
1311		warn "$_me: you must specify a mount-point"
1312		return 1
1313	fi
1314	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1315	if ! mount -t devfs dev "$devdir"; then
1316		warn "$_me: Unable to mount devfs on $devdir"
1317		return 1
1318	fi
1319	if [ -n "$rs" ]; then
1320		devfs_init_rulesets
1321		devfs_set_ruleset $rs $devdir
1322		devfs -m $devdir rule applyset
1323	fi
1324	return 0
1325}
1326
1327# devfs_mount_jail dir [ruleset]
1328#	Mounts a devfs file system appropriate for jails
1329#	on the directory dir. If ruleset is specified, the ruleset
1330#	it names will be used instead.  If present, ruleset must
1331#	be the name of a ruleset as defined in a devfs.rules(5) file.
1332#	This function returns non-zero if an error occurs.
1333#
1334devfs_mount_jail()
1335{
1336	local jdev rs _me
1337	jdev="$1"
1338	[ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1339	_me="devfs_mount_jail"
1340
1341	devfs_init_rulesets
1342	if ! devfs_domount "$jdev" $rs; then
1343		warn "$_me: devfs was not mounted on $jdev"
1344		return 1
1345	fi
1346	return 0
1347}
1348
1349# Provide a function for normalizing the mounting of memory
1350# filesystems.  This should allow the rest of the code here to remain
1351# as close as possible between 5-current and 4-stable.
1352#   $1 = size
1353#   $2 = mount point
1354#   $3 = (optional) extra mdmfs flags
1355mount_md()
1356{
1357	if [ -n "$3" ]; then
1358		flags="$3"
1359	fi
1360	/sbin/mdmfs $flags -s $1 md $2
1361}
1362
1363# Code common to scripts that need to load a kernel module
1364# if it isn't in the kernel yet. Syntax:
1365#   load_kld [-e regex] [-m module] file
1366# where -e or -m chooses the way to check if the module
1367# is already loaded:
1368#   regex is egrep'd in the output from `kldstat -v',
1369#   module is passed to `kldstat -m'.
1370# The default way is as though `-m file' were specified.
1371load_kld()
1372{
1373	local _loaded _mod _opt _re
1374
1375	while getopts "e:m:" _opt; do
1376		case "$_opt" in
1377		e) _re="$OPTARG" ;;
1378		m) _mod="$OPTARG" ;;
1379		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1380		esac
1381	done
1382	shift $(($OPTIND - 1))
1383	if [ $# -ne 1 ]; then
1384		err 3 'USAGE: load_kld [-e regex] [-m module] file'
1385	fi
1386	_mod=${_mod:-$1}
1387	_loaded=false
1388	if [ -n "$_re" ]; then
1389		if kldstat -v | egrep -q -e "$_re"; then
1390			_loaded=true
1391		fi
1392	else
1393		if kldstat -q -m "$_mod"; then
1394			_loaded=true
1395		fi
1396	fi
1397	if ! $_loaded; then
1398		if ! kldload "$1"; then
1399			warn "Unable to load kernel module $1"
1400			return 1
1401		else
1402			info "$1 kernel module loaded."
1403		fi
1404	else
1405		debug "load_kld: $1 kernel module already loaded."
1406	fi
1407	return 0
1408}
1409
1410# ltr str src dst
1411#	Change every $src in $str to $dst.
1412#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1413#	awk(1).
1414ltr()
1415{
1416	local _str _src _dst _out _com
1417	_str=$1
1418	_src=$2
1419	_dst=$3
1420	_out=""
1421
1422	IFS=${_src}
1423	for _com in ${_str}; do
1424		if [ -z "${_out}" ]; then
1425			_out="${_com}"
1426		else
1427			_out="${_out}${_dst}${_com}"
1428		fi
1429	done
1430	echo "${_out}"
1431}
1432
1433# Creates a list of providers for GELI encryption.
1434geli_make_list()
1435{
1436	local devices devices2
1437	local provider mountpoint type options rest
1438
1439	# Create list of GELI providers from fstab.
1440	while read provider mountpoint type options rest ; do
1441		case ":${options}" in
1442		:*noauto*)
1443			noauto=yes
1444			;;
1445		*)
1446			noauto=no
1447			;;
1448		esac
1449
1450		case ":${provider}" in
1451		:#*)
1452			continue
1453			;;
1454		*.eli)
1455			# Skip swap devices.
1456			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1457				continue
1458			fi
1459			devices="${devices} ${provider}"
1460			;;
1461		esac
1462	done < /etc/fstab
1463
1464	# Append providers from geli_devices.
1465	devices="${devices} ${geli_devices}"
1466
1467	for provider in ${devices}; do
1468		provider=${provider%.eli}
1469		provider=${provider#/dev/}
1470		devices2="${devices2} ${provider}"
1471	done
1472
1473	echo ${devices2}
1474}
1475
1476# Find scripts in local_startup directories that use the old syntax
1477#
1478find_local_scripts_old () {
1479	zlist=''
1480	slist=''
1481	for dir in ${local_startup}; do
1482		if [ -d "${dir}" ]; then
1483			for file in ${dir}/[0-9]*.sh; do
1484				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1485				    continue
1486				zlist="$zlist $file"
1487			done
1488			for file in ${dir}/[^0-9]*.sh; do
1489				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1490				    continue
1491				slist="$slist $file"
1492			done
1493		fi
1494	done
1495}
1496
1497find_local_scripts_new () {
1498	local_rc=''
1499	for dir in ${local_startup}; do
1500		if [ -d "${dir}" ]; then
1501			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1502				case "$file" in
1503				*.sample) ;;
1504				*)	if [ -x "$file" ]; then
1505						local_rc="${local_rc} ${file}"
1506					fi
1507					;;
1508				esac
1509			done
1510		fi
1511	done
1512}
1513
1514# check_required_{before|after} command
1515#	Check for things required by the command before and after its precmd,
1516#	respectively.  The two separate functions are needed because some
1517#	conditions should prevent precmd from being run while other things
1518#	depend on precmd having already been run.
1519#
1520check_required_before()
1521{
1522	local _f
1523
1524	case "$1" in
1525	start)
1526		for _f in $required_vars; do
1527			if ! checkyesno $_f; then
1528				warn "\$${_f} is not enabled."
1529				if [ -z "$rc_force" ]; then
1530					return 1
1531				fi
1532			fi
1533		done
1534
1535		for _f in $required_dirs; do
1536			if [ ! -d "${_f}/." ]; then
1537				warn "${_f} is not a directory."
1538				if [ -z "$rc_force" ]; then
1539					return 1
1540				fi
1541			fi
1542		done
1543
1544		for _f in $required_files; do
1545			if [ ! -r "${_f}" ]; then
1546				warn "${_f} is not readable."
1547				if [ -z "$rc_force" ]; then
1548					return 1
1549				fi
1550			fi
1551		done
1552		;;
1553	esac
1554
1555	return 0
1556}
1557
1558check_required_after()
1559{
1560	local _f _args
1561
1562	case "$1" in
1563	start)
1564		for _f in $required_modules; do
1565			case "${_f}" in
1566				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
1567				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
1568				*)	_args="${_f}" ;;
1569			esac
1570			if ! load_kld ${_args}; then
1571				if [ -z "$rc_force" ]; then
1572					return 1
1573				fi
1574			fi
1575		done
1576		;;
1577	esac
1578
1579	return 0
1580}
1581
1582fi
1583
1584_rc_subr_loaded=:
1585